bind dcc n fsetup dcc_fsetup
proc fsetup2 {idx passed} {
  global chanserv trigger autopass defaultattr fserverattr enforce onjoin onjoinmsg onjoinnotice joinmsg onadvertise advertise relaytime ratio flag2 pnick maxidle
  global ratio rationumber freecredits ratioup ratiodown
  global onjoin onjoinmsg onjoinnotice joinmsg
  global onadvertise advertise
  set place [set pnick($idx)]
  set option [lindex $passed 0]
  set var [lrange $passed 1 end]
  switch $option {
    1 {
      if {$place == "0"} {
        putdcc $idx "Selected REGULAR OPTIONS..."
        set pnick($idx) "1"
        opt1 $idx
        return 0
      }
      if {$place == "1"} {
        if {$var == ""} {
          putdcc $idx "Channel Serv"
          putdcc $idx "Currently set to: $chanserv"
          putdcc $idx " "
          putdcc $idx "  Channel that the eggdrop will serve the File Server"
          putdcc $idx "  If you want your eggdrop to serve all channels it is on,"
          putdcc $idx "    set it to '*'"
          putdcc $idx " "
          putdcc $idx "  Syntax: 1 \[chan2serve\]"
          putdcc $idx "    chan2serve is the channel you want your bot to serve"
          putdcc $idx " "
          putdcc $idx "  Examples:"
          putdcc $idx "   To make your bot serve all channels it is on, type '1 *'"
          putdcc $idx "   To make your bot serve #lame, type '1 #lame'"
          return 0
        }
        set chanserv $var
        putdcc $idx "Channel Serv"
        putdcc $idx "Now serving $chanserv"
        opt1 $idx
        return 0
      }
      if {$place == "2"} {
        if {$var == ""} {dcc_ratio $idx;return 0}
        if {$var == "on"} {set var "ON"}
        if {$var == "off"} {set var "OFF"}
        if {$var != "OFF" && $var != "ON"} {
          putdcc $idx " "
          putdcc $idx "Wrong syntax!"
          putdcc $idx " "
          dcc_ratio $idx
          return 0
        }
        set ratio $var
        putdcc $idx "Ratio"
        putdcc $idx "Ratio is now $ratio"
        check_ratio
        opt2 $idx
        return 0
      }
      if {$place == "3"} {
        if {$var == ""} {dcc_onjoin $idx;return 0}
        if {$var == "on"} {set var "ON"}
        if {$var == "off"} {set var "OFF"}
        if {$var != "OFF" && $var != "ON"} {
          putdcc $idx " "
          putdcc $idx "Wrong syntax!"
          putdcc $idx " "
          dcc_onjoin $idx
          return 0
        }
        set onjoin $var
        putdcc $idx "On Join"
        putdcc $idx "On Join is now $onjoin"
        opt3 $idx
        return 0
      }
      if {$place == "4"} {
        if {$var == ""} {dcc_onadvertise $idx;return 0}
        if {$var == "on"} {set var "ON"}
        if {$var == "off"} {set var "OFF"}
        if {$var != "OFF" && $var != "ON"} {
          putdcc $idx " "
          putdcc $idx "Wrong syntax!"
          putdcc $idx " "
          dcc_onadvertise $idx
          return 0
        }
        set onadvertise $var
        putdcc $idx "Advertising"
        putdcc $idx "Advertising is now $onadvertise"
        opt4 $idx
        return 0
      }
    }
    2 {
      if {$place == "0"} {
        putdcc $idx "Selected RATIO OPTIONS..."
        set pnick($idx) "2"
        opt2 $idx
        return 0
      }
      if {$place == "1"} {
        if {$var == ""} {
          putdcc $idx "FServer Trigger"
          putdcc $idx "Currently set to $trigger"
          putdcc $idx " "
          putdcc $idx "  FServer Trigger is the trigger command that someone has to type from the channel that the bot is serving to get added the the Temporary File Server User List"
          putdcc $idx " "
          putdcc $idx "  Syntax: 2 \[trigger\]"
          putdcc $idx "    trigger is the command that someone will have to type to be added to the FServer List"
          putdcc $idx " "
          putdcc $idx "  Example:"
          putdcc $idx "    To make the trigger command '!fserver', type '2 !fserver'"
          return 0
        }
        set trigger $var
        putdcc $idx "FServer Trigger"
        putdcc $idx "File Server trigger set to $trigger"
        opt1 $idx
        return 0
      }
      if {$place == "2"} {
        if {$var == ""} {dcc_rationumber $idx;return 0}
        set ratiotemp [lindex $var 0]
        set ratioup "OFF"
        set ratio1 "OFF"
        set ratiodown "OFF"
        if {[left $ratiotemp 1] < 10000} {set ratioup [left $rationumber 1]}
        if {[mid $ratiotemp 1 1] == ":"} {set ratio1 [mid $rationumber 1 1]}
        if {[right $ratiotemp 1] < 1000} {set ratiodown [right $rationumber 1]}
        if {$ratioup == "OFF" || $ratio1 == "OFF" || $ratiodown == "OFF"} {
          putdcc $idx "Sorry, wrong syntax!"
          putdcc $idx " "
          dcc_rationumber $idx
          return 0
        }
        set rationumber $ratiotemp
        putdcc $idx "Ratio Number"
        putdcc $idx "Now set to $rationumber"
        opt2 $idx
        return 0
      }
      if {$place == "3"} {
        if {$var == ""} {dcc_onjoinmsg $idx;return 0}
        if {$var == "on"} {set var "ON"}
        if {$var == "off"} {set var "OFF"}
        if {$var != "OFF" && $var != "ON"} {
          putdcc $idx " "
          putdcc $idx "Wrong syntax!"
          putdcc $idx " "
          dcc_onjoinmsg $idx
          return 0
        }
        set onjoinmsg $var
        putdcc $idx "On Join /MSG"
        putdcc $idx "On Join /MSG is now $onjoinmsg"
        opt3 $idx
        return 0
      }
      if {$place == "4"} {
        if {$var == ""} {
          putdcc $idx "Advertisement"
          putdcc $idx "Currently set to:"
          putdcc $idx "  $advertise"
          putdcc $idx " "
          putdcc $idx "  Advertisement will be the Timed Message that the bot will send to the channel(s) it is serving."
          putdcc $idx "  This feature only works if Advertising is turned ON"
          putdcc $idx " "
          putdcc $idx "  Syntax: 2 \[advertisement\]"
          putdcc $idx "    advertisement will be the Timed Message"
          putdcc $idx " "
          putdcc $idx "  Examples:
          putdcc $idx "    To make the Advertisement 'Type !fserver', type '2 Type !fserver'."
          return 0
        }
        set advertise $var
        putdcc $idx "Advertisement"
        putdcc $idx "Now set to: $advertise"
        opt4 $idx
        return 0
      }
    }
    3 {
      if {$place == "0"} {
        putdcc $idx "Selected AUTO JOIN..."
        set pnick($idx) "3"
        opt3 $idx
        return 0
      }
      if {$place == "1"} {
        if {$var == ""} {
          putdcc $idx "Auto Password"
          putdcc $idx "Currently set to $autopass"
          putdcc $idx " "
          putdcc $idx "  Auto Password is the password that will be automaticly set to ONLY people who get into File Server User File. This is the password that they will have to type when they DCC CHAT the bot"
          putdcc $idx " "
          putdcc $idx "  Syntax: 3 \[autopass\]"
          putdcc $idx "    autopass is the password that will be set to FServer Users"
          putdcc $idx " "
          putdcc $idx "  Example:"
          putdcc $idx "    To set the Auto Password to 'fserver', type '3 fserver'"
          return 0
        } 
        set autopass $var
        putdcc $idx "Auto Password"
        putdcc $idx "Auto Password set to $autopass"
        opt1 $idx
        return 0
      }
      if {$place == "2"} {
        if {$var == ""} {dcc_freecredits $idx;return 0}
        if {$var < 100000} {
          set freecredits $var
          putdcc $idx "Free Credits"
          putdcc $idx "Free Credits set to $freecredits"
          opt2 $idx
          return 0
        }
        putdcc $idx "Sorry, wrong syntax!"
        putdcc $idx " "
        dcc_freecredits $idx
      }
      if {$place == "3"} {
        if {$var == ""} {dcc_onjoinnotice $idx;return 0}
        if {$var == "on"} {set var "ON"}
        if {$var == "off"} {set var "OFF"}
        if {$var != "OFF" && $var != "ON"} {
          putdcc $idx " "
          putdcc $idx "Wrong syntax!"
          putdcc $idx " "
          dcc_onjoinnotice $idx
          return 0
        }
        set onjoinnotice $var
        putdcc $idx "On Join /NOTICE"
        putdcc $idx "On Join /NOTICE is now $onjoinnotice"
        opt3 $idx
        return 0
      }
      if {$place == "4"} {
        if {$var == ""} {dcc_relaytime $idx;return 0}
        if {$var < 100000} {
          set relaytime $var
          putdcc $idx "Advertise Timer"
          putdcc $idx "Advertise Timer is now set to $onjoinnotice"
          opt4 $idx
          return 0
        }
        putdcc $idx " "
        putdcc $idx "Wrong syntax!"
        putdcc $idx " "
        dcc_relaytime $idx
        return 0
      }
    }
    4 {
      if {$place == "0"} {
        putdcc $idx "Selected ADVERTISING..."
        set pnick($idx) "4"
        opt4 $idx
        return 0
      }
      if {$place == "1"} {
        if {$var == ""} {
          putdcc $idx "Default Attr"
          putdcc $idx "Currenty set to $defaultattr"
          putdcc $idx " "
          putdcc $idx "  For advanced users."
          putdcc $idx "  Default Attributes are the attributes that are given to the File Server Users"
          putdcc $idx "  Very Recommended to leave them as '+x-ipfjomn'."
          putdcc $idx " "
          putdcc $idx "  Syntax: 4 \[attributes\]"
          putdcc $idx "    attributes will be the attributes File Server users will have"     
          putdcc $idx " "
          putdcc $idx "  Example:"
          putdcc $idx "    To set Default Attributes to '+x-ipfjomn', type '4 +x-ipfjomn'"
          return 0
        }
        set defaultattr $var
        putdcc $idx "Default Attr"
        putdcc $idx "Default Attributes set to $defaultattr"
        opt1 $idx
        return 0
      }
      if {$place == "2"} {opt2 $idx;return 0}
      if {$place == "3"} {
        if {$var == ""} {
          putdcc $idx "On Join NOTE"
          putdcc $idx "Currently set to:"
          putdcc $idx "  $joinmsg"
          putdcc $idx " "
          putdcc $idx "  On Join NOTE is the PRIVATE MESSAGE or/and NOTICE that the bot will send as someone joins the channel(s) the bot is serving."
          putdcc $idx "  This will NOT work if On Join /MSG or/and On Join /NOTICE are turned OFF."
          putdcc $idx "  On Join /MSG and On Join /NOTICE do NOT work if On Join is set OFF"
          putdcc $idx " "
          putdcc $idx "  Syntax: 4 \[message\]"
          putdcc $idx "    message will be the note that the bot will send"
          putdcc $idx " "
          putdcc $idx "  Example:"
          putdcc $idx "    If you want the note to be 'Type !fserver to reach my file server!',"
          putdcc $idx "    type: '4 Type !fserver to reach my file server!'."
          return 0
        }
        set joinmsg $var
        putdcc $idx "On Join NOTE"
        putdcc $idx "On Join NOTE is now $joinmsg"
        opt3 $idx
        return 0
      }
      if {$place == "4"} {opt4 $idx;return 0}
    }
    5 {
      if {$place == "0"} {fsetup3 $idx;return 0}
      if {$place == "1"} {
        if {$var == ""} {
          putdcc $idx "FServer Attr"
          putdcc $idx "Currently set to $fserverattr"
          putdcc $idx " "
          putdcc $idx "  File Server Attribute is the attribute that a File Server User will have."
          putdcc $idx "  Make sure that it is not set to any existing attributes."
          putdcc $idx "  It is recommended to leave it as 'q'"
          putdcc $idx " "
          putdcc $idx "  Syntax: 5 \[attribute\]"
          putdcc $idx "    attribute will be the File Server Attribute"
          putdcc $idx " "
          putdcc $idx "  Example:"
          putdcc $idx "    To make the File Server Attribute 'q', type '5 q'"
          return 0
        }
        set v1 [left $var 1]
        if {$v1 == "n" || $v1 == "m" || $v1 == "o" || $v1 == "p" || $v1 == "j" || $v1 == "x" || $v1 == "a" || $v1 == "h" || $v1 == "b" || $v1 == "d" || $v1 == "k" || $v1 == "r" || $v1 == "s"} {
          putdcc $idx "Sorry, but the $v1 attribute is already taken, please try another one."
          return 0
        }
        set flag2 $v1
        set fserverattr $flag2
        putdcc $idx "FServer Attr"
        putdcc $idx "File Server Attribute is now $fserverattr"
        opt1 $idx
        return 0
      }
      if {$place == "2"} {
        putdcc $idx " "
        putdcc $idx "Returning to Main Menu..."
        putdcc $idx " "
        set pnick($idx) "0"
        fsetup3 $idx
        return 0
      }
      if {$place == "3"} {opt3 $idx;return 0}
      if {$place == "4"} {
        putdcc $idx " "
        putdcc $idx "Returning to Main Menu..."
        putdcc $idx " "
        set pnick($idx) "0"
        fsetup3 $idx
        return 0
      }
    }
    6 {
      if {$place == "0"} {
        putdcc $idx "Returning to Party Line..."
        unset pnick($idx)
        return 1
      }
      if {$place == "1"} {
        if {$var == ""} {dcc_enforce $idx;return 0}
        if {$var == "on"} {set var "ON"}
        if {$var == "off"} {set var "OFF"}
        if {$var != "OFF" && $var != "ON"} {
          putdcc $idx " "
          putdcc $idx "Wrong syntax!"
          putdcc $idx " "
          dcc_enforce $idx
          return 0
        }
        set enforce $var
        putdcc $idx "Enforce Mode"
        putdcc $idx "Enforce Mode is now $enforce"
        opt1 $idx
        return 0
      }
      if {$place == "2"} {
        putdcc $idx " "
        putdcc $idx "Unavailable command. Commands are 1-5."
        putdcc $idx " "
        return 0
      }
      if {$place == "3"} {
        putdcc $idx " "
        putdcc $idx "Returning to Main Menu..."
        putdcc $idx " "
        set pnick($idx) "0"
        fsetup3 $idx
        return 0
      }
      if {$place == "4"} {
        putdcc $idx " "
        putdcc $idx "Unavailable command. Commands are 1-6."
        putdcc $idx " "
        return 0
      }
    }
    7 {
      if {$place == "0"} {
        putdcc $idx " "
        putdcc $idx "Unavailable command. Commands are 1-6."
        putdcc $idx " "
        fsetup3 $idx
        return 0
      }
      if {$place == "1"} {
        if {$var == ""} {dcc_maxidle $idx;return 0}
        if {$var < 100000} {
          set maxidle $var
          putdcc $idx "Maximun Idle"
          putdcc $idx "Now set to $maxidle minutes"
          opt1 $idx
          return 0
        }
        putdcc $idx " "
        putdcc $idx "Wrong syntax!"
        putdcc $idx " "
        dcc_maxidle $idx
        return 0
      }
      if {$place == "2"} {
        putdcc $idx " "
        putdcc $idx "Unavailable command. Commands are 1-5."
        putdcc $idx " "
        return 0
      }
      if {$place == "3"} {
        putdcc $idx " "
        putdcc $idx "Unavailable command. Commands are 1-6."
        putdcc $idx " "
        opt3 $idx
        return 0
      }
      if {$place == "4"} {
        putdcc $idx " "
        putdcc $idx "Unavailable command. Commands are 1-6."
        putdcc $idx " "
        return 0
      }
    }
    8 {
      if {$place == "0"} {
        putdcc $idx " "
        putdcc $idx "Unavailable command. Commands are 1-6."
        putdcc $idx " "
        fsetup3 $idx
        return 0
      }
      if {$place == "1"} {opt1 $idx;return 0}
      if {$place == "2"} {
        putdcc $idx " "
        putdcc $idx "Unavailable command. Commands are 1-5."
        putdcc $idx " "
        return 0
      }
      if {$place == "3"} {
        putdcc $idx " "
        putdcc $idx "Unavailable command. Commands are 1-6."
        putdcc $idx " "
        opt3 $idx
        return 0
      }
      if {$place == "4"} {
        putdcc $idx " "
        putdcc $idx "Unavailable command. Commands are 1-6."
        putdcc $idx " "
        return 0
      }
    }
    9 {
      if {$place == "0"} {
        putdcc $idx " "
        putdcc $idx "Unavailable command. Commands are 1-6."
        putdcc $idx " "
        fsetup3 $idx
        return 0
      }
      if {$place == "1"} {
        putdcc $idx " "
        putdcc $idx "Returning to Main Menu..."
        putdcc $idx " "
        set pnick($idx) "0"
        fsetup3 $idx
        return 0
      }
      if {$place == "2"} {
        putdcc $idx " "
        putdcc $idx "Unavailable command. Commands are 1-5."
        putdcc $idx " "
        return 0
      }
      if {$place == "3"} {
        putdcc $idx " "
        putdcc $idx "Unavailable command. Commands are 1-6."
        putdcc $idx " "
        opt3 $idx
        return 0
      }
      if {$place == "4"} {
        putdcc $idx " "
        putdcc $idx "Unavailable command. Commands are 1-6."
        putdcc $idx " "
        return 0
      }
    }
    exit {
      putdcc $idx "Returning to Party Line..."
      unset pnick($idx)
      return 1
    }
    default {
      if {$place == "0"} {
        putdcc $idx " "
        putdcc $idx "Unavailable command. Commands are 1-6."
        putdcc $idx " "
        fsetup3 $idx
        return 0
      }
      if {$place == "1"} {
        putdcc $idx " "
        putdcc $idx "Unavailable command. Commands are 1-9."
        putdcc $idx " "
        opt1 $idx
        return 0
      }
      if {$place == "2"} {
        putdcc $idx " "
        putdcc $idx "Unavailable command. Commands are 1-5."
        putdcc $idx " "
        return 0
      }
      if {$place == "3"} {
        putdcc $idx " "
        putdcc $idx "Unavailable command. Commands are 1-6."
        putdcc $idx " "
        opt3 $idx
        return 0
      }
      if {$place == "4"} {
        putdcc $idx " "
        putdcc $idx "Unavailable command. Commands are 1-6."
        putdcc $idx " "
        return 0
      }
    }
  }
}

proc dcc_fsetup { hand idx passed } {
  global pnick
  set pnick($idx) "0"
  control $idx fsetup2
  fsetup3 $idx
  return 1
}


proc fsetup3 {idx} {
  putdcc $idx " "
  putdcc $idx "   File Server v2.0 by canuckle"
  putdcc $idx "     Option            | About"
  putdcc $idx "     ----------------------------------------------------------------"
  putdcc $idx "   \[1\] Regular         | Channel Serv, Fserver Trigger, Auto Password,"
  putdcc $idx "                       |  Default Attr, FServer Attr, Enforce Mode"
  putdcc $idx "   \[2\] Ratio Options   | Ratio ON/OFF, Ratio Number, Free Credits"
  putdcc $idx "   \[3\] Auto JOIN       | On Join ON/OFF, On Join /MSG, On join /NOTICE,"
  putdcc $idx "                       |  On Join Note"
  putdcc $idx "   \[4\] Advertising     | Advertise ON/OFF, Advertisement"
  putdcc $idx "   \[5\] Repeat Message  | Main Menu"
  putdcc $idx "   \[6\] Quit FSetup     | Go back to Party Line."
  putdcc $idx " "
  putdcc $idx "               Type 1-6 or 'exit' to exit."
  fserver_save
  return 0
}

proc opt1 {idx} {
  global chanserv trigger autopass defaultattr fserverattr enforce maxidle
  putdcc $idx " "
  putdcc $idx "   File Server v2.0 by canuckle"
  putdcc $idx "                          *** REGULAR ***"
  putdcc $idx "     Option            | About                   | Status"
  putdcc $idx "     ----------------------------------------------------------------"
  putdcc $idx "   \[1\] Channel Serv    | Channel to Serve        | $chanserv  (* = ALL)"
  putdcc $idx "   \[2\] FServer Trigger | Command to be added     | $trigger"
  putdcc $idx "   \[3\] Auto Password   | Set to File Users       | $autopass"
  putdcc $idx "   \[4\] Default Attr    | Attributes set to Users | $defaultattr"
  putdcc $idx "   \[5\] FServer Attr    | Attribute of FServer    | $fserverattr"
  putdcc $idx "   \[6\] Enforce Mode    | Enforce FServer to chan | $enforce"
  putdcc $idx "   \[7\] Maximun Idle    | FServer Users Max Idle  | $maxidle"
  putdcc $idx "   \[8\] Repeat Message  | Repeat Message          | Regular Menu"
  putdcc $idx "   \[9\] Main Menu       | Back to Main Menu       | Now in REGULAR Menu"
  putdcc $idx " "
  putdcc $idx "               Type 1-9 or 'exit' to exit."
  fserver_save
  return 0
}

proc opt2 {idx} {
  global ratio rationumber freecredits
  putdcc $idx " "
  putdcc $idx "   File Server v2.0 by canuckle"
  putdcc $idx "                      *** RATIO OPTIONS ***"
  putdcc $idx "     Option            | About                   | Status"
  putdcc $idx "     ----------------------------------------------------------------"
  putdcc $idx "   \[1\] Ratio           | ON or OFF               | $ratio"
  putdcc $idx "   \[2\] Ratio Number    | Ratio Quantity          | $rationumber"
  putdcc $idx "   \[3\] Free Credits    | Credits to Server Users | $freecredits"
  putdcc $idx "   \[4\] Repeat Message  | Repeat Message          | Ratio Options Menu"
  putdcc $idx "   \[5\] Main Menu       | Back to Main Menu       | Now in Ratio Menu"
  putdcc $idx " "
  putdcc $idx "               Type 1-5 or 'exit' to exit."
  fserver_save
  return 0
}

proc opt3 {idx} {
  global onjoin onjoinnotice onjoinmsg joinmsg
  putdcc $idx " "
  putdcc $idx "   File Server v2.0 by canuckle"
  putdcc $idx "                    *** AUTO ON JOIN ***"
  putdcc $idx "     Option            | About                   | Status"
  putdcc $idx "     ----------------------------------------------------------------"
  putdcc $idx "   \[1\] On Join         | Send note on join       | $onjoin"
  putdcc $idx "   \[2\] On Join /MSG    | Send a /MSG on join     | $onjoinmsg"
  putdcc $idx "   \[3\] On Join /NOTICE | Send a /NOTICE on join  | $onjoinnotice"
  putdcc $idx "   \[4\] On Join NOTE    | The note sent on join   | *"
  putdcc $idx "   \[5\] Repeat Message  | Repeat Message          | Auto Join Menu"
  putdcc $idx "   \[6\] Main Menu       | Back to Main Menu       | Now in Auto Join"
  putdcc $idx " "
  putdcc $idx "   *  $joinmsg"
  putdcc $idx " "
  putdcc $idx "               Type 1-6 or 'exit' to exit."
  fserver_save
  return 0
}

proc opt4 {idx} {
  global onadvertise advertise relaytime
  putdcc $idx " "
  putdcc $idx "   File Server v2.0 by canuckle"
  putdcc $idx "                    *** ADVERTISING ***"
  putdcc $idx "     Option            | About                   | Status"
  putdcc $idx "     ----------------------------------------------------------------"
  putdcc $idx "   \[1\] Advertising     | Advertises to the chan  | $onadvertise"
  putdcc $idx "   \[2\] Advertisement   | Note that will be sent  | *"
  putdcc $idx "   \[3\] Advertise Timer | Time between Advertises | $relaytime"
  putdcc $idx "   \[4\] Repeat Message  | Repeat Message          | Advertising Menu"
  putdcc $idx "   \[5\] Main Menu       | Back to Main Menu       | Now in Advertising"
  putdcc $idx " "
  putdcc $idx "   *  $advertise"
  putdcc $idx " "
  putdcc $idx "               Type 1-5 or 'exit' to exit."
  fserver_save
  return 0
}

proc dcc_enforce {idx} {
  global enforce
  putdcc $idx "Enforce Mode"
  putdcc $idx "Currently set $enforce"
  putdcc $idx " "
  putdcc $idx "  Enforce Mode when set 'ON' is strict on having the User inside the channel the bot is serving when the User is using the File System."
  putdcc $idx "  Enforce Mode when set 'OFF' is not script on having the User inside the channel the bot is serving when the User is using the File System."
  putdcc $idx " "
  set em {[ON/OFF]}
  putdcc $idx "  Syntax: 6 $em"
  putdcc $idx "    ON/OFF sets the Enforce Mode ON if it is 'ON' or OFF when it is 'OFF'."
  putdcc $idx " "
  putdcc $idx "  Examples:"
  putdcc $idx "    If you want Enforce Mode ON, type '6 ON'."
  putdcc $idx "    If you want Enforce Mode OFF, type '6 OFF'."
  return 0
}

proc dcc_ratio {idx} {
  global ratio
  putdcc $idx "Ratio ON/OFF"
  putdcc $idx "Currently set to $ratio"
  putdcc $idx " "
  putdcc $idx "  Ratio serves File Server Users for free when turned OFF and"
  putdcc $idx "  Ratio does not serves File Server User when turned ON"
  putdcc $idx " "
  putdcc $idx "  Syntax: 1 \[ON/OFF\]"
  putdcc $idx "    ON/OFF will determine if you want the File Server serving for free or not"
  putdcc $idx " "
  putdcc $idx "  Examples:"
  putdcc $idx "    To make your bot Enable Ratio, type '1 ON'"
  putdcc $idx "    To make your bot Disable Ratio, type '1 OFF'"
  return 0
}

proc dcc_rationumber {idx} {
   global rationumber
   putdcc $idx "Ratio Number"
   putdcc $idx "Currently set to $rationumber"
   putdcc $idx " "
   putdcc $idx "  This only works if Ratio is Turned ON"
   putdcc $idx "  If the ratio number is set to \"1:2\", then the File Server User will be able to download 2 files every 1 file he/she sends."
   putdcc $idx "  If the ratio number is set to \"1:1\", then the File Server User will be able to download 1 file every 1 file he/she sends."
   putdcc $idx "  If 'x' will be the number of files that the File Server User sends, and 'y' will be the number he can download, then the ratio number will be 'x:y'"
   putdcc $idx " "
   putdcc $idx "  Syntax: 2 \[rationumber\]"
   putdcc $idx "    rationumber will be the number to determine the ratio number"
   putdcc $idx " "
   putdcc $idx " Examples:"
   putdcc $idx "   To make the ratio be '1:7', type '2 1:7'"
   putdcc $idx "   To make the ratio be '1:500', type '2 1:500'"
   return 0
}

proc dcc_freecredits {idx} {
  global freecredits
  putdcc $idx "Free Credits"
  putdcc $idx "Currently set to $freecredits"
  putdcc $idx " "
  putdcc $idx "  Free Credits are the credits that every File Server User get when they first use the File Server"
  putdcc $idx "  When someone gets automatically added to the File Server, he gets those credits for free."
  putdcc $idx "  A credit is a File Download, so each credit is 1 file"
  putdcc $idx " "
  putdcc $idx "  Syntax: 3 \[credits\]"
  putdcc $idx "    credits will be how many free credits each File Server User will have"
  putdcc $idx " "
  putdcc $idx "  Example:"
  putdcc $idx "    To make 5 files free credits, type '3 5'."
  return 0
}

proc dcc_onjoin {idx} {
  global onjoin
  putdcc $idx "On Join"
  putdcc $idx "Currently set to $onjoin"
  putdcc $idx " "
  putdcc $idx "  On Join when set ON will be able to send private messages or/and notices to someone as he joins the channel(s) the bot is serving."
  putdcc $idx "  On Join when set OFF will not send any sort of message to someone as he joins the channel(s) the bot is serving."
  putdcc $idx " "
  putdcc $idx "  Syntax: 1 \[ON/OFF\]"
  putdcc $idx "    ON/OFF will determine if the bot will send a message or not"
  putdcc $idx " "
  putdcc $idx "  Examples:"
  putdcc $idx "    To make the On Join ON, type '1 ON'."
  putdcc $idx "    To make the On Join OFF, type '1 OFF'."
  return 0
}

proc dcc_onjoinmsg {idx} {
  global onjoinmsg
  putdcc $idx "On Join /MSG"
  putdcc $idx "Currently set to $onjoinmsg"
  putdcc $idx " "
  putdcc $idx "  On Join /MSG when set ON will send a PRIVATE MESSAGE to someone as he joins the channel(s) the bot is serving."
  putdcc $idx "  On Join /MSG when set OFF will not send a PRIVATE MESSAGE to someone as he joins the channel(s) the bot is serving."
  putdcc $idx "  This feature only works if On Join is set ON"
  putdcc $idx " "
  putdcc $idx "  Syntax: 2 \[ON/OFF\]"
  putdcc $idx "    ON/OFF will determine if the bot will send a private message or not on join."
  putdcc $idx " "
  putdcc $idx "  Examples:"
  putdcc $idx "    To make the bot send a private message, type '2 ON'."
  putdcc $idx "    To make the bot NOT send a private message, type '2 OFF'."
  return 0
}

proc dcc_onjoinnotice {idx} {
  global onjoinnotice
  putdcc $idx "On Join /NOTICE"
  putdcc $idx "Currently set to $onjoinnotice"
  putdcc $idx " "
  putdcc $idx "  On Join /NOTICE when set ON will send a NOTICE to someone as he joins the channel(s) the bot is serving."
  putdcc $idx "  On Join /NOTICE when set OFF will send a NOTICE to someone as he joins the channel(s) the bot is serving."
  putdcc $idx " "
  putdcc $idx "  Syntax: 3 \[ON/OFF\]"
  putdcc $idx "    ON/OFF will determine if the bot will send a notice or not"
  putdcc $idx " "
  putdcc $idx "  Examples:"
  putdcc $idx "    To make the bot send a NOTICE, type '3 ON'"
  putdcc $idx "    To make the bot NOT send a NOTICE, type '3 OFF'"
  return 0
}

proc dcc_onadvertise {idx} {
  global onadvertise
  putdcc $idx "Advertising"
  putdcc $idx "Currently set to $onadvertise"
  putdcc $idx " "
  putdcc $idx "  Advertising is a timer which sends a timed Advertisement to the channel."
  putdcc $idx "  If turned ON, it will send a timed advertise to the channel(s) it is serving."
  putdcc $idx "  If turned OFF, it will nto send a timed advertise to teh channel(s) it is serving."
  putdcc $idx " "
  putdcc $idx "  Syntax: 1 \[ON/OFF\]"
  putdcc $idx "    ON/OFF will determine if the bot will send a timed advertise or not"
  putdcc $idx " "
  putdcc $idx "  Examples:"
  putdcc $idx "    To make the bot send a Timed Advertisement, type '1 ON'"
  putdcc $idx "    To make the bot NOT send a Timed Advertisement, type '1 OFF'"
  return 0
}

proc dcc_relaytime {idx} {
  global relaytime
  putdcc $idx "Advertise Timer"
  putdcc $idx "Currently set to $relaytime"
  putdcc $idx " "
  putdcc $idx "  Advertise Timer is the time that the bot will wait between Advertisements in minutes."
  putdcc $idx "  This feature only works if Advertising is turned ON."
  putdcc $idx " "
  putdcc $idx "  Syntax: 3 \[time\]"
  putdcc $idx "    time will be the Time the bot will wait between Advertises."
  putdcc $idx " "
  putdcc $idx "  Example:"
  putdcc $idx "    To set the Advertise Timer to 5 minutes, type '3 5'"
  return 0
}

proc dcc_maxidle {idx} {
  global maxidle
  putdcc $idx "Maximun Idle"
  putdcc $idx "Currently set to $maxidle minutes"
  putdcc $idx " "
  putdcc $idx "  Maximun Idle is the maximun time that the File Server User can stay logged on the Bot without typing a command."
  putdcc $idx "  If the user passes this limit, he is automaticly booted from the bot"
  putdcc $idx " "
  putdcc $idx "  Syntax: 7 \[time\]"
  putdcc $idx "    time will be the max time that a FServer User can idle"
  putdcc $idx " "
  putdcc $idx "  Example:"
  putdcc $idx "    To set the Maximun Idle time to 5 minutes, type '7 5'."
  return 0
}

